=begin
#YapStone Dispute Composite Service

#This service provides a Dispute engine that enables a Marketplace to manage Disputes and Dispute related objects like Evidences on processed Payments. 

The version of the OpenAPI document: v1
Contact: cbkdev@yapstone.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class AuthenticationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Authenticate Partner
    # Get an access token. It is OAuth2, and you must use the client credentials grant type. The token will allow you to authenticate with the other internal payments API endpoints. 
    # @param grant_type [String] To do OAuth2 authentication, you must indicate the grant type, then adhere to it structurally. Yapstone API endpoints authenticate with OAuth2 and the grant type client credentials. This type of authentication is used to access resources on your own system rather than access a user&#39;s resources. 
    # @param authorization [String] Provide client_id:client_secret as base64 encoded basic auth. 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse200]
    def authenticate_partner(grant_type, authorization, opts = {})
      data, _status_code, _headers = authenticate_partner_with_http_info(grant_type, authorization, opts)
      data
    end

    # Authenticate Partner
    # Get an access token. It is OAuth2, and you must use the client credentials grant type. The token will allow you to authenticate with the other internal payments API endpoints. 
    # @param grant_type [String] To do OAuth2 authentication, you must indicate the grant type, then adhere to it structurally. Yapstone API endpoints authenticate with OAuth2 and the grant type client credentials. This type of authentication is used to access resources on your own system rather than access a user&#39;s resources. 
    # @param authorization [String] Provide client_id:client_secret as base64 encoded basic auth. 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse200, Integer, Hash)>] InlineResponse200 data, response status code and response headers
    def authenticate_partner_with_http_info(grant_type, authorization, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationApi.authenticate_partner ...'
      end
      # verify the required parameter 'grant_type' is set
      if @api_client.config.client_side_validation && grant_type.nil?
        fail ArgumentError, "Missing the required parameter 'grant_type' when calling AuthenticationApi.authenticate_partner"
      end
      # verify the required parameter 'authorization' is set
      if @api_client.config.client_side_validation && authorization.nil?
        fail ArgumentError, "Missing the required parameter 'authorization' when calling AuthenticationApi.authenticate_partner"
      end
      # resource path
      local_var_path = '/v1/oauth2/client_credential/accesstoken'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'grant_type'] = grant_type

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'Authorization'] = authorization

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse200' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationApi#authenticate_partner\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
